/*====================================================================
t@CF	dprintf.c
@\TvF		SCI@\gpPC̃R\[ɕo͂܂B
				rbg[gF19200bps
				f[^F8bit
				peBF
				XgbvrbgF1
				t[F
====================================================================*/
#include "iodefine.h"
#include "dprintf.h"
#include <stdarg.h>
#ifdef __cplusplus				// Remove the comment when you use SIM I/O
extern "C" {
	
rsdout dout;

#endif


#ifndef byte
#define byte unsigned char
#endif

/*====================================================================
gɊݒs܂B
}N"USE_AKI-3664"`ĂꍇAg16MHzƂĐݒs܂B
ĂȂꍇ͎g20MHzƂĐݒs܂B
====================================================================*/
//#define USE_AKI-3664

#ifndef USE_AKI-3664
//20MHz 19200,n,8,1̐ݒ(BRR=20h)
#define MSMR	0x00
#define	MBRR	0x20
#else
//16MHz 19200,n,8,1̐ݒ(BRR=19h)
#define MSMR	0x00
#define	MBRR	0x19
#endif

//RSꂽǂ̃tO
static unsigned char IsRsInit=0;

/*====================================================================
֐F	rsinit
@\F		SCIIȌs܂B
====================================================================*/
void rsinit()
{
	IO.PMR1.BIT.TXD=1;
	SCI3.SMR.BYTE=MSMR;
	SCI3.SCR3.BYTE=0x00;
	SCI3.BRR=MBRR;
	SCI3.SSR.BIT.OER=0;
	SCI3.SSR.BIT.FER=0;
	SCI3.SSR.BIT.PER=0;
	SCI3.SSR.BIT.TDRE=0;
	SCI3.SCR3.BIT.TE=1;
	SCI3.SSR.BIT.RDRF=0;
	SCI3.SCR3.BIT.RE=1;		//Recieve Enable
	IsRsInit=1;
}

/*====================================================================
֐F	_rsputc
@\F		char^1R\[o͂A0Ԃ܂B
====================================================================*/
int _rsputc(char c)
{
	if(!IsRsInit)
		rsinit();
	while(!(SCI3.SSR.BIT.TDRE));
	SCI3.TDR=c;
	return 0;
}

/*====================================================================
֐F	rsputc
@\F		char^1R\[o͂܂B
			s̏ꍇASCIIR[hCRo͂܂B
====================================================================*/
int rsputc(char c)
{
	if(c=='\n')
		_rsputc(0x0d);
	return _rsputc(c);
}

/*====================================================================
֐F	rsputs
@\F		k|C^ɓ܂ŕo͂܂B
====================================================================*/
char *rsputs(char *str)
{
	while(*str){
		rsputc(*str);
		str++;
	}
	return str;
}

/*====================================================================
֐F	rsdgetc
@\F		R\[1󂯎Ė߂lƂĕԂ܂B
			f[^ĂȂꍇ-1Ԃ܂B
====================================================================*/
int rsdgetc()
{
	int dat=-1;

	if(!IsRsInit) rsinit();

	if(SCI3.SSR.BIT.RDRF){		/*Mf[^݂ꍇ*/
		dat=SCI3.RDR;
		SCI3.SSR.BIT.RDRF=0;
	}
	/*G[tONA*/
	if(SCI3.SSR.BIT.OER)
		SCI3.SSR.BIT.OER=0;
	if(SCI3.SSR.BIT.FER)
		SCI3.SSR.BIT.FER=0;
	if(SCI3.SSR.BIT.PER)
		SCI3.SSR.BIT.PER=0;
	return dat;
}

/*====================================================================
֐F	rsgetc
@\F		R\[1󂯎Ė߂lƂĕԂ܂B
			f[^ĂȂꍇ̓|[Ođ҂܂B
====================================================================*/
int rsgetc()
{
	int c;
	do {
		c=rsdgetc();
	}while(c==-1);
	return c;
}

/*====================================================================
֐F	convx
@\F		𕶎ɕϊ܂B
			dat:	ϊ鐔
			base:	
			clms:	\i܂߂čő7j
			fill:	󔒂ɖ߂R[h
			߂l͕ϊ̐擪̃|C^łB
			̏I̓kłB
====================================================================*/
char * convx(int dat,int base,int clms,char fill)
{
	const char *dspc="0123456789ABCDEF";
	static char buff[8];
	int cnt;
	int ip=7;
	int d;
	char sgn;

	if(dat<0){
		sgn='-';
		dat=-dat;
	}else{
		sgn=' ';
	}

	buff[7]=0;		/*LSB̓k*/
	do{
		ip--;
		d=dat % base;
		buff[ip]=dspc[d];
		dat/=base;
	}while(dat && ip);
	cnt=clms-(7-ip);
	while((cnt>0)&&(ip>0)){
		ip--;
		buff[ip]=fill;
		cnt--;
	}

	if(sgn=='-'){
		ip--;
		buff[ip]=sgn;
	}
	return &buff[ip];
}

/*====================================================================
֐F	write
@\F		o͐w肵ăR\[o͂܂B
			buf:	o͂镶̃|C^
			cntF	o͕
			߂lcnt̒l̂܂ܕԂ܂B
====================================================================*/
int write(char *buf,int cnt)
{
	int i;
	for(i=0;i<cnt;i++){
		rsputc(buf[i]);
	}
	return cnt;
}

/*====================================================================
֐F	dprintf
@\F		printf̐o[WłB
			fmtF	\
			dprintf͎̕ϊT|[g܂B
			%cF	char^1
			%sF	char*
			%nxF	int^16i\܂B
			%niF	int^10i\܂B
			%nxA%ndnʒuɂ͕\܂Bn0Ŏn܂ꍇA\鐔̌\ɖȂꍇAcOŖ߂܂B
====================================================================*/
void dprintf(const char *fmt, ...)
{
	va_list ap;
	char *p,*sval,c;
	char fillchr;
	char clms;
	int ival;
	
	va_start(ap,fmt);
	for(p=fmt;*p;p++){
		if(*p!='%'){
			rsputc(*p);
			continue;
		}
		p++;
		fillchr=' ';
		clms=0;
		//FillChar`FbN('0')̂
		if(*p=='0'){
			fillchr='0';
			p++;
		}
		while((*p>='0')&&(*p<='9')){
			clms=clms*10+(*p-'0');
			p++;
		}
		switch(*p){
		case 'c':
		case 'C':
			c=va_arg(ap,int);
			rsputc(c);
			break;
		case 'd':
		case 'D':
			ival=va_arg(ap,int);
			rsputi(ival,clms,fillchr);
			break;
		case 'x':
		case 'X':
			ival=va_arg(ap,int);
			rsputx(ival,clms,fillchr);
			break;
		case 's':
		case 'S':
			for(sval=va_arg(ap,char *);*sval; sval++)
				rsputc(*sval);
			break;
		default:
			rsputc(*p);
		}
	}
	va_end(ap);
}

/*====================================================================
֐F	tprintf
@\F		dprintf̏o͐obt@ɑւo[WłB
			buffF	o͐̃obt@
			fmtF	o͕
====================================================================*/
void tsprintf(char *buff,const char *fmt, ...)
{
	va_list ap;
	char *p,*sval,c,*cp;
	char fillchr;
	char clms;
	int ival;
		
	va_start(ap,fmt);
	for(p=fmt;*p;p++){
		if(*p!='%'){
			*buff=*p;	buff++;
			continue;
		}
		p++;
		fillchr=' ';
		clms=0;
		//FillChar`FbN('0')̂
		if(*p=='0'){
			fillchr='0';
			p++;
		}
		while((*p>='0')&&(*p<='9')){
			clms=clms*10+(*p-'0');
			p++;
		}
		switch(*p){
		case 'c':
		case 'C':
			c=va_arg(ap,int);
			*buff=*p;	buff++;
			break;
		case 'd':
		case 'D':
			ival=va_arg(ap,int);
			cp=convx(ival,10,clms,fillchr);	
			while(*cp){
				*buff=*cp;	buff++;
				cp++;
			}
			break;
		case 'x':
		case 'X':
			ival=va_arg(ap,int);
			cp=convx(ival,16,clms,fillchr);	
			while(*cp){
				*buff=*cp;	buff++;
				cp++;
			}
			break;
		case 's':
		case 'S':
			for(sval=va_arg(ap,char *);*sval; sval++){
				*buff=*p;	buff++;
			}
			break;
		default:
				*buff=*p;	buff++;
		}
	}
	va_end(ap);
	*buff=0;
}

#ifdef __cplusplus				// Remove the comment when you use SIM I/O
}
#endif
