/***********************************************************************/
/*                                                                     */
/*  FILE        :SLib.c                                                */
/*  DATE        :Mon, Sep 22, 2003                                     */
/*  DESCRIPTION :Main Program                                          */
/*  CPU TYPE    :H8/3664F                                              */
/*                                                                     */
/*  This file is generated by Hitachi Project Generator (Ver.2.1).     */
/*                                                                     */
/***********************************************************************/
                  
#include "slib.h"
#include "dprintf.h"
#include "PS2KBD.h"
#include "timerA.h"
#include "iodefine.h"
#include "lcd.h"
#include "machine.h"
#ifdef __cplusplus
extern "C" {
#endif
void abort(void);
#ifdef __cplusplus
}
#endif

/*-------------------------------------------------------
SWITCH UNITS
-------------------------------------------------------*/
void SwInterruptEnable()
{
	//For Switch-1
	IO.PMR1.BIT.IRQ2=1;
	IEGR1.BIT.IEG2=1;
	IENR1.BIT.IEN2=1;
	//For Switch-2
	IO.PMR1.BIT.IRQ3=1;
	IEGR1.BIT.IEG3=1;
	IENR1.BIT.IEN3=1;
	//P81,P82 PORT DIRECTION
	IO.PCR8|=0x06;
}

//IRQ荞݂fBZ[uALEDB
void SwInterruptDisable()
{
	IENR1.BIT.IEN2=0;
	IENR1.BIT.IEN3=0;
	IO.PDR8.BIT.B1=1;
	IO.PDR8.BIT.B2=1;
}

//S2ꂽ̊荞ݏBIRQ2̊荞݃xN^łꂪs
void Irq2()
{
	IRR1.BIT.IRRI2=0;
	IO.PDR8.BIT.B1=~IO.PDR8.BIT.B1;
}

//S3ꂽ̊荞ݏBIRQ3̊荞݃xN^łꂪs
void Irq3()
{
	IRR1.BIT.IRRI3=0;
	IO.PDR8.BIT.B2=~IO.PDR8.BIT.B2;
}

/*-------------------------------------------------------
XCb`̃eXg֐
-------------------------------------------------------*/
void SwTest()
{
	int c;
	const static char *msg="XCb`LED̃eXgłB\n"
		"S1ƐԂLED_łAS2ƉFLED_ł܂B\n"
		"^[~iŉL[ƏI܂B\n";
	dprintf(msg);
	SwInterruptEnable();
	do {
		c=rsdgetc();
	}while(c==-1);
	SwInterruptDisable();
}

/*-------------------------------------------------------
FAN CONTROL UNITS
-------------------------------------------------------*/
volatile int FanRPM=0;			//FanCntTvO邱ƂɂA]x𓾂B
extern volatile int FanCnt;		//pXJEgB1bɃNA

/*-------------------------------------------------------
TÅ荞ݖɎs֐
TÅ荞݂ɂA1bԊuŎs֐
-------------------------------------------------------*/
void FanTimer()
{
	FanRPM=FanCnt;
	FanCnt=0;
}

volatile int PWMDat=0;	//PWM"ON"̋Ԃ\ϐ
volatile int pwmcnt=0;	//PWM̃JE^

/*-------------------------------------------------------
TÅ荞ݖɎs֐
t@̓d̃XCb`OiP84ŐjPWMŐ䂷
-------------------------------------------------------*/
void PWMTimer()
{

	//PWM Control
	if(pwmcnt<PWMDat){
		IO.PDR8.BIT.B4=1;
	}else{
		IO.PDR8.BIT.B4=0;
	}
	pwmcnt++;
	if(pwmcnt>=63)
		pwmcnt=0;
	
}

/*-------------------------------------------------------
t@̂߂̏֐
-------------------------------------------------------*/
void FanCtrlInit()
{
	IO.PCR8|=0x10;			//P84o͂ɐݒ
	IO.PMR1.BIT.IRQ0=1;		//P14it@̃pXjIRQ0荞݂Ɏgp
	IEGR1.BIT.IEG0=1;		//IRQ0̗オGbWo
	IENR1.BIT.IEN0=1;		//IRQ0荞݃Cl[ui荞ݖFanCnt++j
	FanCnt=0;
	TW.TMRW.BIT.CTS=0;		//TWJEgXgbv
	TW.TMRW.BIT.PWMD=0;
	TW.TCRW.BIT.CCLR=0;
	SetPTimer(FanTimer,1000);	//TAF1000ms̊
	SetTimerA(PWMTimer);		//TAFI[o[t[̊荞
}

//TimerWgAPWM^CvFanControl
void FanCtrlInit2()
{
	IO.PMR1.BIT.IRQ0=1;		//P14it@̃pXjIRQ0荞݂Ɏgp
	IEGR1.BIT.IEG0=1;		//IRQ0̗オGbWo
	IENR1.BIT.IEN0=1;		//IRQ0荞݃Cl[u
	FanCnt=0;
	TW.TMRW.BIT.CTS=1;		//TWJEgX^[g
	TW.TMRW.BIT.PWMD=1;		//P84/FTIODPWMo
	TW.TCRW.BIT.CCLR=1;		//RyA}b`AɂJE^NA
	TW.TCRW.BIT.CKS=3;		//1/8clock
	TW.TCRW.BIT.TOD=0;		//TimerOutputLevel
	TW.GRA=0xff;
	TW.GRD=0;

	SetPTimer(FanTimer,1000);	//1000ms̊
	SetTimerA(0);
}

/*-------------------------------------------------------
^C}Agt@Rg[̃eXg
-------------------------------------------------------*/
void FanTest()
{
	char str[20];
	int ad1;		//RV1̒l
	int rpm;		//]
	int i;
	const static char *msg="^C}Agpt@Rg[̃eXgłB\n"
		"Ẽ{[񂷂ƃt@̉]ω܂B\n"
		"^[~iŉL[ƏI܂B\n";
	dprintf(msg);

	FanCtrlInit();

	LcdDisplayMode(true,false,false);		//LCD̃J[\OFF
	//A/D Reg Init
	AD.ADCSR.BYTE=0;		//芸0NA
	AD.ADCSR.BIT.SCAN=1;	//XLx[h
	AD.ADCSR.BIT.CH=2;	//AN0`AN2I

	AD.ADCSR.BIT.ADST=1;	//ϊX^[g

	while(!AD.ADCSR.BIT.ADF) ;	//ADϊI҂
	do {
		ad1=(int)(AD.ADDRA>>8);	//AN0iRV3jADϊʂ̏8bit擾
		rpm=FanRPM*30;
		PWMDat=ad1 / 4;
		tsprintf(str,"Val=%d,rpm=%d   ",ad1,rpm);
		LcdXy(0,1);	LcdPuts(str);
		msdelay(10);
	}while(rsdgetc()==-1);		//R\[͂ԌJԂ
	for(i=0;i<19;i++) str[i]=' ';
	str[19]=0;
	LcdXy(0,1);	LcdPuts(str);
	PWMDat=0;
	IO.PDR8.BIT.B4=0;	//t@̃Xgbv
	LcdDisplayMode(true,true,false);
}

/*-------------------------------------------------------
^C}Wgt@Rg[̃eXg
-------------------------------------------------------*/
void FanTest2()
{
	char str[20];
	int ad1,rpm;
	int i;
	const static char *msg="^C}Wgpt@Rg[̃eXgłB\n"
		"Ẽ{[񂷂ƃt@̉]ω܂B\n"
		"^[~iŉL[ƏI܂B\n";
	dprintf(msg);
	FanCtrlInit2();

	//Cursol OFF
	LcdDisplayMode(true,false,false);
	//A/D Reg Init
	AD.ADCSR.BYTE=0;		//芸0NA
	AD.ADCSR.BIT.SCAN=1;	//XL[h
	AD.ADCSR.BIT.CH=2;	//AN0`AN2

	//ADϊX^[g
	AD.ADCSR.BIT.ADST=1;

	while(!AD.ADCSR.BIT.ADF);	//ADϊI܂őҋ@
	do {
			ad1=(int)(AD.ADDRA>>8);
			rpm=FanRPM*30;
			TW.GRD=ad1;
			tsprintf(str,"Val=%d,rpm=%d       ",ad1,rpm);
			LcdXy(0,1);	LcdPuts(str);
			msdelay(10);
	}while(rsdgetc()==-1);
	for(i=0;i<19;i++)
		str[i]=' ';
	str[19]=0;
	LcdXy(0,1);	LcdPuts(str);
	TW.GRD=0;
	IO.PDR8.BIT.B4=0;
	LcdDisplayMode(true,true,false);
	FanCtrlInit();
}

/*-------------------------------------------------------
TIMER UNITS
-------------------------------------------------------*/
void msdelayTest()
{
	dprintf("msdelay Test\n");
	dprintf("count 5000ms start!\n");
	msdelay(5000);
	dprintf("count end.\n");
}

/*-------------------------------------------------------
vJE^eXg
-------------------------------------------------------*/
void watchTest()
{
	int sec;
	const static char *msg="^C}AgpṽeXgłB\n"
		"235955bA5bԃJEgďI܂B\n";
	dprintf(msg);
	SecCnt=55;
	HourCnt=23;
	MinCnt=59;
	FreeTimer=0;
	while(FreeTimer<200){
		sec=SecCnt;
		dprintf("%02d:%02d:%02d\n",HourCnt,MinCnt,SecCnt);
		while(sec==SecCnt);	
	}

}

/*-------------------------------------------------------
R\[o̓eXg
-------------------------------------------------------*/
void dprintfTest()
{
	int c;
	dprintf("dprintf test:\n");
	dprintf("Hit any key(end='x'):\n");
	do{
		c=rsgetc();
		dprintf("key=%c\n",c);
	}while(c!='x');
}

/*-------------------------------------------------------
PS/2L[{[heXg
-------------------------------------------------------*/
void PS2Test()
{
	int c;
	const static char *msg="PS/2L[{[h̃eXgłB\n"
		"ڑPS/2L[{[h͂ꂽL[\܂B\n"
		"^[~i'x'L[ƏI܂B\n";
	dprintf(msg);
	PS2Init();
	//PS/2 Keyboard test ===================
	dprintf("PS/2 Keyboard test:\n");
	dprintf("Hit any key from PS/2 Keyboard(end='x'):\n");
	do {
		c=PS2dgetc();
		if(c!=-1)
			dprintf("key=%c\n",c);
		c=rsdgetc();
	}while(c!='x');
}

/*-------------------------------------------------------
LCD\@\eXg
-------------------------------------------------------*/
void LcdTest()
{
	const static char *msg="LCD\@\eXgłB\n"
		"L[ƁALCD1sڂɕ\s܂B\n";
	dprintf(msg);
	rsgetc();
	LcdCls();
	LcdPuts("This is Line 1.");
	dprintf("L[ƁALCD2sڂɕ\s܂B\n");
	rsgetc();
	LcdXy(0,1);
	LcdPuts("This is Line 2.");
	dprintf("L[ƁAI܂B\n");
	rsgetc();
	LcdCls();
	LcdPuts("LCD Ready...");
}

/*-------------------------------------------------------
ADRo[^@\eXg
-------------------------------------------------------*/
void ADTest()
{
	char str[20];
	int ad1,ad2,ad3;
	int i;
	const static char *msg="A/DRo[^@\̃eXgłB\n"
		"LCD2sڂ̒ĺAA/Dϊ̒li0-255jŁA\n"
		"{[FE{[FOA/D[q@̒lƂȂ܂B\n"
		"OA/D[qiCN5)ɃT[~X^CdSڑƁARl̕ωǂݎ邱Ƃł܂B\n"
		"̏ꍇ́AJP2ɃV[gshĂmFĂB\n"
		"^[~iŉL[ƏI܂B\n";
	dprintf(msg);

	//Cursol OFF
	LcdDisplayMode(true,false,false);
	//A/D Reg Init
	AD.ADCSR.BYTE=0;
	AD.ADCSR.BIT.SCAN=1;
	AD.ADCSR.BIT.CH=2;

	//Start
	AD.ADCSR.BIT.ADST=1;

	while(!AD.ADCSR.BIT.ADF) ;
	do {
			ad1=(int)(AD.ADDRA>>8);
			ad2=(int)(AD.ADDRB>>8);
			ad3=(int)(AD.ADDRC>>8);

			tsprintf(str,"%d:%d:%d    ",ad2,ad1,ad3);
			LcdXy(0,1);	LcdPuts(str);
			msdelay(10);
	}while(rsdgetc()==-1);
	//LCD2sڂ̏
	for(i=0;i<19;i++) str[i]=' ';
	str[19]=0;
	LcdXy(0,1);	LcdPuts(str);
	LcdDisplayMode(true,true,false);
}


/*-------------------------------------------------------
^C}WgXs[J[̃eXg
-------------------------------------------------------*/
void SpkTest()
{
	char str[20];
	int ad1,ad2;
	unsigned int freq,vol;	//TimerW-Cpgݒƃ{[ݒ
	int i;
	const static char *msg="^C}WgpXs[J[̃eXgłB\n"
		"̃{[ŎgAẼ{[ŉʂω܂B\n"
		"^[~iŉL[ƏI܂B\n";
	dprintf(msg);

	//
	TW.TMRW.BIT.CTS=1;		//TWJEgX^[g
	TW.TMRW.BIT.PWMC=1;		//P83/FTIOCPWMo(Xs[J[o)
	TW.TCRW.BIT.CCLR=1;		//RyA}b`AɂJE^NA
	TW.TCRW.BIT.CKS=3;		//1/8clock
	TW.TCRW.BIT.TOC=1;		//ŏ̃RyA}b`܂ŁAo͂Pɂ
	TW.GRA=0xffff;			//Œg20MHz/8/65536=38Hz
	TW.GRC=0;

	//Cursol OFF
	LcdDisplayMode(true,false,false);
	//A/D Reg Init
	AD.ADCSR.BYTE=0;		//芸0NA
	AD.ADCSR.BIT.SCAN=1;	//XL[h
	AD.ADCSR.BIT.CH=2;	//AN0`AN2

	//ADϊX^[g
	AD.ADCSR.BIT.ADST=1;

	while(!AD.ADCSR.BIT.ADF);	//ADϊI܂őҋ@
	do {
			ad1=(int)(AD.ADDRA>>8);
			ad2=(int)(AD.ADDRB>>8);
			freq=(255-ad2)<<8;
			vol=(freq>>1)/(256-ad1);
			TW.GRA=freq;
			TW.GRC=vol;
			tsprintf(str,"Freq=%d,Vol=%d       ",ad2,ad1);
			LcdXy(0,1);	LcdPuts(str);
			msdelay(10);
	}while(rsdgetc()==-1);
	for(i=0;i<19;i++)
		str[i]=' ';
	str[19]=0;
	LcdXy(0,1);	LcdPuts(str);
	TW.TMRW.BIT.CTS=0;		//TWJEgXgbv
	TW.GRC=0;
	IO.PDR8.BIT.B3=0;
	LcdDisplayMode(true,true,false);
}

/*-------------------------------------------------------
	I2CfoCX݃eXg
-------------------------------------------------------*/
void I2cWriteTest()
{
	unsigned char dat[8];
	int i;
	const static char *msg="I2CfoCX(24C02)݂̏̃eXgłB\n"
		"Cӂ8I2CfoCXɏ݂܂\n";
	dprintf(msg);

	dprintf("^[~iCӂ8͂Ă\n");
	//I2CfoCXւ̏========================
	IO.PCR8|=1;			//Bit0o͂ɂ
	IO.PDR8.BIT.B0=0;	//I2CfoCXւ̓d
	for(i=0;i<8;i++){
		dat[i]=rsgetc();
		dprintf("dat[%d]=%02X (%c)\n",i,dat[i],dat[i]);
		//PoCg̏
		I2CMode(1);		//݃[hɃZbg
		StartCondition();
		ByteWrite(0xa0);	//Device Address
		ByteWrite(i);		//Write Address
		ByteWrite(dat[i]);	//Write Data
		StopCondition();
	}


	//===============================================
	dprintf("݂͏I܂BL[ƏI܂B\n");
	rsgetc();
	IO.PDR8.BIT.B0=1;	//I2CfoCXւ̓d߂
}

/*-------------------------------------------------------
	I2CfoCXǂݏoeXg
-------------------------------------------------------*/
void I2cReadTest()
{
	unsigned char dat[8];
	int i;
	const static char *msg="I2CfoCX(24C02)̓ǂݍ݂̃eXgłB\n"
		"I2CfoCX̐擪8oCgǂݏoĕ\܂B\n";
	dprintf(msg);

	//I2CfoCX̓ǂݍ========================
	IO.PCR8|=1;			//Bit0o͂ɂ
	IO.PDR8.BIT.B0=0;	//I2CfoCXւ̓d
	for(i=0;i<8;i++){
		I2CMode(1);		//݃[hɃZbg
		StartCondition();
		ByteWrite(0xa0);	//Device Address
		ByteWrite(i);		//Write Address
		StartCondition();
		ByteWrite(0xa1);	//Device Address
		I2CMode(0);		//ǂݍ݃[hɃZbg
		dat[i]=ByteRead();
		StopCondition();
		dprintf("dat[%d]=%02X (%c)\n",i,dat[i],dat[i]);
	}
	//===============================================
	dprintf("L[ƏI܂B\n");
	rsgetc();
	IO.PDR8.BIT.B0=1;	//I2CfoCXւ̓d߂
}

/*-------------------------------------------------------
Cj[	
-------------------------------------------------------*/
int SelectMenu()
{
	int SelNo;
	const static char *MenuStr=
		"==================[eXgj[]==================\n"
		"1.FANRg[eXg\n"
		"2.PS/2L[{[heXg\n"
		"3.LED/XCb`eXg\n"
		"4.veXg\n"
		"5.LCDeXg\n"
		"6.A/DRo[^eXg\n"
		"7.Xs[J[eXg\n"
		"8.I2CfoCX݃eXg\n"
		"9.I2CfoCXǂݏoeXg\n"
		"eXgԍ:";
	dprintf(MenuStr);
	do{
		SelNo=rsgetc()-'0';
	}while((SelNo<1)||(SelNo>9));
	return SelNo;

}

/*-------------------------------------------------------
C֐
-------------------------------------------------------*/
void main(void)
{
	int item;
	
	//Initialize ===========================
	TimerAInit();
	LcdInit(8);

	dprintf("H8-BASE Test Program Ver 2.00\n");
	LcdPuts("H8-BASE Ready...");

	while(1){
	item=SelectMenu();
	TimerAInit();
	dprintf("%d\n\n",item);
	switch(item){
	case 1:
		FanTest();
		break;
	case 2:
		PS2Test();
		break;
	case 3:
		SwTest();
		break;
	case 4:
		watchTest();
		break;
	case 5:
		LcdTest();
		break;
	case 6:
		ADTest();
		break;
	case 7:
		SpkTest();
		break;
	case 8:
		I2cWriteTest();
		break;
	case 9:
		I2cReadTest();
		break;
	}
	}
}

void abort(void)
{
	
}
